const getRandomFromArray = array => array[Math.floor(Math.random() * array.length)]

const chaosCpsMods = [3, 2, 0.1, 1, 1.5, 1.6, 0, 1.1, 1.1, 1.26]
const chaosAvg = () => chaosCpsMods.reduce((total, next) => total + next, 0) / chaosCpsMods.length
//const getChaos = offset => chaosCpsMods[(Math.floor(new Date().getSeconds() / chaosCpsMods.length) + offset) % chaosCpsMods.length]
const getChaos = offset => chaosCpsMods[(Math.floor(new Date().getSeconds() / chaosCpsMods.length)) % chaosCpsMods.length]

const quackStore = {
  ascent: {
    name: 'Ascent',
    type: 'cps',
    emoji: 'rocket',
    description: 'Welcome to level 2. Boosts all CPS by 20%',
    effect: cps => cps * 1.2,
    cost: 1
  },
  nuclearFuel: {
    name: 'Nuclear Fuel',
    type: 'cps',
    emoji: 'atom_symbol',
    description: 'The future is now. Boosts all CPS by 20%.',
    preReqs: ['ascent'],
    effect: cps => cps * 1.2,
    cost: 5
  },
  chaos: {
    name: 'Chaos',
    type: 'cps',
    emoji: 'eye',
    description: 'Awaken. Gives a random modifier to your CPS every six seconds. May have other consequences...',
      //+ '_\n_Averages a 26% CPS boost.',
    preReqs: ['nuclearFuel'],
    effect: (cps, user) => {
      return cps * getChaos(Math.round(user.interactions / 50))
    },
    cost: 10
  },

  dryerSheet: {
    name: 'Dryer Sheet',
    type: 'lightning',
    emoji: 'rose',
    description: 'Smells nice. Makes lightning twice as likely to strike.',
    effect: lightningOdds => lightningOdds * 2,
    preReqs: ['nuclearFuel'],
    cost: 10
  },

  // Checked Upgrades. Have no effect(), but their existence is referred to elsewhere.
  theGift: {
    name: 'The Gift',
    type: 'checked',
    emoji: 'eye-in-speech-bubble',
    description: 'Become forewarned of certain events...',
    preReqs: ['dryerSheet', 'chaos'],
    cost: 10
  },

  theVoice: {
    name: 'The Voice',
    type: 'checked',
    emoji: 'loud_sound',
    description: 'Unlocks the !speak command',
    preReqs: ['dryerSheet', 'chaos'],
    cost: 50
  },

  cheeseBaby: {
    name: 'cheeseBaby',
    type: 'starter',
    emoji: 'baby_symbol',
    description: 'Start each prestige with 5 mice',
    preReqs: ['dryerSheet', 'chaos'],
    effect: user => {
      user.items.mouse ??= 0
      user.items.mouse += 5
    },
    cost: 5
  },

  silverSpoon: {
    name: 'Silver Spoon',
    type: 'starter',
    emoji: 'spoon',
    description: 'Start each prestige with 5 accountants',
    preReqs: ['cheeseBaby'],
    effect: user => {
      user.items.accountant ??= 0
      user.items.accountant += 5
    },
    cost: 10
  },

  oceanMan: {
    name: 'Ocean Man',
    type: 'starter',
    emoji: 'ocean',
    description: 'Start each prestige with 5 whales',
    preReqs: ['silverSpoon'],
    effect: user => {
      user.items.whale ??= 0
      user.items.whale += 5
    },
    cost: 20
  }
}

module.exports = {
  quackStore,
  getChaos: user => getChaos(user.interactions || 0)
}
